#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <utility>

using namespace std;

vector <pair <long long, long long>> to_pair(long long hv, long long k, long long minn, long long maxx, long long a, long long b) {
    vector <pair <long long, long long>> ans = {{0, k}, {k, 0}};
    if (hv == 0) {
        if (k < b) {
            return {{0, k}};
        } else if (k < a) {
            return {{k, 0}};
        } else {
            return {};
        }
    }
    long long stop = k;
    minn = max(minn, hv / stop);
    maxx = min(maxx, (long long) sqrt(hv));
    maxx = min(maxx, stop);
    if (sqrt(hv) < stop) {
        stop = sqrt(hv);
    }
    for (int i = min(minn, maxx); i < max(maxx, minn); i += 1) {
        if (hv % i == 0) {
            ans.push_back({i, hv / i});
            ans.push_back({hv / i, i});
        }
    }
    return ans;
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i += 1) {
        long long a, b, k, m;
        cin >> a >> b >> k >> m;
        vector <pair <long long, long long>> t = to_pair(m - k - 1, k, min(a, b), max(a, b), a, b);
        pair <long long, long long> ans = {-1, -1};
        for (pair <long long, long long> elem : t) {
            if (elem.first < a && elem.second < b) {
                if (elem.second > ans.second) {
                    ans = elem;
                }
            } if (elem.second < a && elem.first < b) {
                if (elem.first > ans.second) {
                    ans = {elem.first, elem.second};
                }
            }
        } if (ans.first == -1) {
            cout << -1 << "\n";
        } else {
            cout << ans.first << " " << ans.second << "\n";
        }
    }
    return 0;
}
