#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

vector <vector <long long>> engines;
long long n, p;

long long comp_p(long long x) {
    long long ans = 0;
    for (int i = 0; i < n; i += 1) {
        if (x <= engines[i][0]) {
            ans += engines[i][1] * x;
        } else {
            ans += (engines[i][1] * engines[i][0] + engines[i][2] * (x - engines[i][0]));
        }
    }
    return ans;
}

int main() {
    cin >> n >> p;
    engines = vector <vector <long long>> (n, vector <long long> (3)); // [z, a, b]
    for (int i = 0; i < n; i += 1) {
        cin >> engines[i][0] >> engines[i][1] >> engines[i][2];
    }
    long long x = 10000000;
    long long ac = 5000000;
    while (ac > 5) {
        if (comp_p(x) > p) {
            x -= ac;
        } else {
            x += ac;
        }
        ac /= 2;
    }
    x -= 10;
    for (int i = 0; i < 20; i += 1) {
        if (comp_p(x) >= p) break;
        x += 1;
    }
    cout << x;
    return 0;
}
