#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

long long a, b, k, m;

pair <long long, long long> search() {
    long long h = 0, v = 0;
    long long max_v = b - 1;
    for (long long i = m / b; i <= sqrt(m); i += 1) {
        if (i > a) {
            return {-1, -1};
        }
        if (m % i == 0) {
            h = i - 1;
            v = m / i - 1;
            if (v > max_v) {
                continue;
            }
            if (v + h == k) {
                return {h, v};
            }
        }
    }
    return {-1, -1};
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i += 1) {
    cin >> a >> b >> k >> m;
    pair <long long, long long> ans = search();
    if (ans.first == -1) {
        cout << -1 << "\n";
    } else {
        cout << ans.first << " " << ans.second << "\n";
    }
    }
    return 0;
}
