#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    vector <int> a(n);
    for (int i = 0; i < n; i += 1) {
        cin >> a[i];
    }
    vector <vector <int>> ans(n, vector <int> (n, 0)); // i - index, j - step
    for (int i = 0; i < n; i += 1) {
        int l = i, r = i; // левая и правая границы
        ans[i][0] += 1;
        for (int step = 1; step <= n; step += 1) {
            if (l == 0 && r == n - 1) break;
            if (l == 0) {
                r += 1;
                ans[r][step] += 1;
            } else if (r == n - 1) {
                l -= 1;
                ans[l][step] += 1;
            } else {
                if (a[l - 1] > a[r + 1]) {
                    r += 1;
                    ans[r][step] += 1;
                }
                else {
                    l -= 1;
                    ans[l][step] += 1;
                }
            }
        }
    }
    for (int i = 0; i < q; i += 1) {
        int a, b;
        cin >> a >> b;
        cout << ans[a - 1][b - 1] << "\n";
    }
    return 0;
}
